---
documentType: index
title: Orleankka Documentation
tagline: Functional API for Microsoft Orleans
---
<style>
.subtitle {
    font-size:20px;
}
.jumbotron{
    text-align: center;
    background-color: inherit;
}
img.main-logo{
    max-width: 70%;
    max-height: 70%;
    text-align: center;
}
h2:before{
    display: none;
}
.centered {
    text-align: center;
}
</style>

<section>
<div class="container centered">
  <img src="images/Logo.Full.jpg" class="main-logo" />
</section>

<section>
    <div class="container centered">
        <h2 class="lead">Orleankka is a <strong>functional</strong> extension for <a href="http://dotnet.github.io/orleans/" target="_blank">Microsoft Orleans</a> framework. It provides a message-based API similar to Akka/ProtoActor, carefully layered on top of Microsoft Orleans (that's what in a name). Orleankka is an excellent choice for use-cases which can benefit from <strong>composable</strong>, <strong>uniform</strong> communication interface, such as <strong>CQRS</strong>, <strong>event-sourcing</strong>, <strong>FSM</strong>, etc.</h2>
    </div>
</section>

<section>
<div class="container centered">
  <a class="btn btn-lg btn-primary" href="articles/intro/getting-started-csharp.md">Getting started</a>
</div>
</section>